=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-05-05 06:59:12 +0000
+++ bzrlib/branch.py	2005-05-05 23:28:03 +0000
@@ -691,6 +691,28 @@
         return [l.rstrip('\r\n') for l in self.controlfile('revision-history', 'r').readlines()]
 
 
+    def enum_history(self, direction):
+        """Return (revno, revision_id) for history of branch.
+
+        direction
+            'forward' is from earliest to latest
+            'reverse' is from latest to earliest
+        """
+        rh = self.revision_history()
+        if direction == 'forward':
+            i = 1
+            for rid in rh:
+                yield i, rid
+                i += 1
+        elif direction == 'reverse':
+            i = len(rh)
+            while i > 0:
+                yield i, rh[i-1]
+                i -= 1
+        else:
+            raise BzrError('invalid history direction %r' % direction)
+
+
     def revno(self):
         """Return current revision number for this branch.
 

